pipeline {
    agent {
        docker {
                image 'node:latest'
                label 'centos_vm'
                args '-p 4200:4200'
                }
        }
    environment { 
        HOME = '.' 
        // NPM_CONFIG_PREFIX = "${workspace}/.npm-global"
        // PATH = "$PATH:${workspace}/.npm-global/bin"
        }
    stages {
        stage('SCM') {
            steps {
                echo 'clonning..'
                sh 'node -v'
                git 'https://github.com/jadach1/Simple-Angular-Web-App.git'
            }
        }
  
 
        stage('Build') {
            steps {
                script {
                    try {
                        echo 'Building..'
                        echo "$PATH"
                        sh 'ls -la'
                        sh 'pwd'
                        sh "node -v"
                        sh "npm install @angular/cli &> install_angular.log"
                        sh "npm install"
                    } catch (err) {
                        echo err
                        // echo err.getMessage()
                        currentBuild.result == 'FAILURE'
                    } 
                }
            }
        }
        stage('Test') {
            steps {
                echo 'Testing..'
            }
        }
        stage('Deploy') {
            steps {
                script {
                    try {
                        echo 'Deploying....'
                        sh '''#!/bin/bash
                                npm run build --aot --prod
                            '''
                        sh 'ls'
                        sh 'pwd'
                        sh 'ls src/'
                        sh 'ls src/app'
                        } catch (err) {
                        echo err
                        echo err.toString()
                        echo err.getMessage()
                        echo err.getStackTrace()
                        currentBuild.result == 'FAILURE'
                    }
                }
            }
        }
    
    }

}
